



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WebApi传参总动员(二)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WebApi传参总动员(二)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 04:06:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>上篇，从最简单的string入手。本篇演示了从请求的输入流中获取实体。api：</p>
<div>
<pre class="prettyprint linenums">    public class ValuesController : ApiController<br />
    {

        [HttpPost]<br />
        public string GetData(string name)<br />
        {<br />
            return "我爱" + name;<br />
        }<br />
        [HttpPost]<br />
        public string GetData()<br />
        {<br />
            var stream = HttpContext.Current.Request.InputStream;<br />
            byte[] byts = new byte[stream.Length];<br />
            stream.Read(byts, , (int)stream.Length);<br />
            //以UTF8形式获取数据<br />
            string json = Encoding.UTF8.GetString(byts);<br />
            Woman woman = JsonConvert.DeserializeObject&lt;Woman&gt;(json);<br />
            return woman.Age + "的" + woman.Name;<br />
        }<br />
    }<br />
    public class Woman//仅仅为了演示方便<br />
    {<br />
        public string Name{get;set;}<br />
        public string Age{get;set;}<br />
    }</pre>
</div>
<p>js：</p>
<div>
<pre class="prettyprint linenums">        var woman = { Name: '刘亦菲', Age: 18 };<br />
        $(function () {<br />
            $('#btn').click(function () {<br />
                $.ajax({<br />
                    type: "post",<br />
                    url: "http://localhost:7601/api/values/GetData",<br />
                    data:JSON.stringify(woman),<br />
                    success: function (r) {<br />
                        alert(r);<br />
                    }<br />
                });<br />
            });<br />
        });
</pre>
</div>
<p>结果：<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669688/201510/669688-20151030183529685-941457816.png" />　　</p>
<p>过程和结果都非常简单。但这里面蕴含着一个巨大的坑，你如果做Attribute验证的话。后面讲到的时候再谈。</p>
<p>如果Action的参数中含有一个简单类型和实体对象，形如</p>
<div>
<pre class="prettyprint linenums">[HttpPost]<br />
        public string GetData(string name)<br />
        {<br />
            var stream = HttpContext.Current.Request.InputStream;<br />
            byte[] byts = new byte[stream.Length];<br />
            stream.Read(byts, , (int)stream.Length);<br />
            //以UTF8形式获取数据<br />
            string json = Encoding.UTF8.GetString(byts);<br />
            Woman woman = JsonConvert.DeserializeObject&lt;Woman&gt;(json);<br />
            return name + "喜欢" +woman.Age + "的" + woman.Name;<br />
        }</pre>
</div>
<pre class="prettyprint linenums">只需要在js中将url: "http://localhost:7601/api/values/GetData" 改为 url: "http://localhost:7601/api/values/GetData?name=楼主"即可。则在Action中name参数和实体均能正确获得。<br />由于比较简单，不再赘述。<br />值得一提的是，此方法对于复杂类型的实体对象传递，也能非常好的支持。比如Man类型的实体。</pre>
<div>
<pre class="prettyprint linenums">    public class Person<br />
    {<br />
        public string Name { get; set; }<br />
        public string Age { get; set; }<br />
    }<br />
    public class Man : Person<br />
    {<br />
        public Woman Wife { get; set; }<br />
        public List&lt;Woman&gt; Lovers { get; set; }<br />
    }<br />
    public class Woman : Person<br />
    {<br />
        public int Height { get; set; }<br />
        public List&lt;DateTime&gt; ExerciseTime { get; set; }<br />
    }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93yjm08.html">RIDE -- Robot Framework setup</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ry0z78.html">ipad互动教学</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn2y5jq.html">阿里云docker镜像加速</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kvllr9.html">&lbrack;原创&rsqb;cocos2d-x研习录-第三阶 特性之按键与虚拟键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlme3m19.html">【20160924】GOCVHelper MFC增强算法（3）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd1g7xq.html">微信OAuth2网页授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdn5md8.html">js 全选全不选</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1o6vz9.html">iOS高仿城觅应用客户端项目（开发思路和代码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpxjlq.html">IOS6和IOS7的屏幕适配问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv675zq.html">JAVA常见异常集锦（持续更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1r37gq.html">QConf简要搭建过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjgvz9.html">（转）什么是P问题、NP问题和NPC问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pg16j8.html">vue2&period;0之render函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/960m07v9.html">scrapy之环境安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv207zx9.html">模块&lpar;import语句&comma;from&period;&period;&period;import语句&comma;&lowbar;name&lowbar;属性&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve5yez9.html">PAT甲题题解-1088&period; Rational Arithmetic &lpar;20&rpar;-模拟分数计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/963pxlj9.html">AS打开速度慢，AS项目导入慢，新建项目导入慢</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj5nvvq.html">【pyqt5】QdateTimeEdit（日期时间）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql17m069.html">HTML5练习2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pwyleq.html">html-图片热点和网页划区</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9prejzq.html">Erwin 生成 mysql 带注释&lpar;comment &rpar;的脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7lj59.html">Kafka - 消费接口分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnok739.html">C&num;  RSA PEM解密字符</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k763j9.html">easyui plugin&mdash;&mdash;etreegrid：CRUD Treegrid</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7z5r9.html">查看、关闭linux自启动网络服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq13x258.html">swift 附属脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j34veq.html">MAC自带的SVN进行升级</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j3oe0q.html">git clone简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd2ygj9.html">BAPI 调用相当于BAPI&lowbar;TRANSACTION&lowbar;COMMIT 的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql441e9.html">MAC 入门</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
